<script lang="ts">
  import ScrollImage from "./ScrollImage.svelte";
  import WriteText from "./WriteText.svelte";
  import { onMount } from "svelte";

  let thisWebsiteText: HTMLElement;
  let thisWebsiteImage: HTMLElement;
  let streamyText: HTMLElement;
  let streamyImage: HTMLElement;

  onMount(() => {
    addHoverLineColor("#fc6d26", thisWebsiteText, thisWebsiteImage);
    addHoverLineColor("#0066ff", streamyText, streamyImage);
  })

  function addHoverLineColor(color: string, lineElem: HTMLElement, hoverElem: HTMLElement) {
    let observer = new IntersectionObserver(([entry]) => {
      if (entry.isIntersecting) {
        observer.disconnect();
        setTimeout(() => {
        if(lineElem.classList.contains("leftLine")) {
          lineElem.style.borderLeftStyle = "solid";
        } else if(lineElem.classList.contains("rightLine")) {
          lineElem.style.borderRightStyle = "solid";
        }}, 150);
      }
    });
    observer.observe(lineElem);
    
    let oldColor: string;
    hoverElem.addEventListener("mouseover", () => {
      oldColor = lineElem.style.borderColor;
      lineElem.style.borderColor = color;
    });
    hoverElem.addEventListener("mouseout", () => {
      lineElem.style.borderColor = oldColor;
    });
  }
</script>

<div id="bio">
  <span class="title"><WriteText text={"Hi, I'm Matyáš!"} /></span>
  <span><WriteText text={"I am an enthusiastic full-stack software developer."}/></span>
</div>

<div class="section">
  <span class="title"><WriteText text={"This Website"}/></span>
  <div class="imageText">
    <a bind:this={thisWebsiteImage} href="https://gitlab.com/7dub-projects/website"><ScrollImage imgSrc={"/socials/gitlab_logo.svg"}/>The website repository</a>
    <div bind:this={thisWebsiteText} class="leftLine">
      <span><WriteText text={"The boring portfolio website you're viewing right now."}/></span>
      <span><WriteText text={"Written by yours truly in Svelte."}/></span>
    </div>
    <div class="grow"></div>
  </div>
</div>

<div class="right section">
  <span class="title"><WriteText text={"Streamy"}/></span>
  <div class="imageText">
    <div class="grow"></div>
    <div bind:this={streamyText} class="rightLine">
      <span><WriteText text={"One audio solution for all broadcasts."}/></span>
      <span><WriteText text={"WIP"}/></span>
    </div>
    <a bind:this={streamyImage} href="https://streamy.7dub.dev/"><ScrollImage imgSrc={"/streamy_logo.svg"}/>Streamy website</a>
  </div>
</div>

<style>
  #bio {
    display: flex;
    flex-direction: column;
    align-content: center;
    width: 100%;
    margin-bottom: calc(10vh + 10vw);
  }
  #bio .title {
    font-size: calc(5vw + 1rem);
    font-weight: 600;
    margin-bottom: 0.3em;
  }
  #bio span {
    font-size: calc(1.7vw + 1rem);
    min-height: 1em;
    text-align: center;
  }

  .section {
    display: flex;
    flex-direction: column;
    margin-bottom: 20vh;
  }
  .section span {
    min-height: 1em;
    font-size: calc(1vw + 1rem);
    letter-spacing: -1.2px;
  }
  .section .title {
    font-size: calc(3vw + 1rem);
    font-weight: 600;
    margin-bottom: 0.2em;
    letter-spacing: 0px;
  }

  .imageText {
    display: flex;
    flex-direction: row;
  }

  .imageText > div {
    display: flex;
    flex-direction: column;
    justify-content: center;
    margin-left: 3em;
    margin-right: 3em;
  }

  .leftLine {
    border-left: none;
    border-color: #F7F7FF;
    border-left-width: 0.5em;
    padding-left: 1em;
    transition: border-color 0.2s;
  }
  
  .rightLine {
    border-right: none;
    border-color: #F7F7FF;
    border-right-width: 0.5em;
    padding-right: 1em;
    transition: border-color 0.2s;
  }

  .right span {
    text-align: right;
  }

  a {
    font-size: 0;
  }

  .grow {
    flex-grow: 1;
  }

  @media (max-width: 1200px) {
    #bio .title {
      font-size: calc(4vw + 1rem);
    }
    #bio span {
      font-size: calc(1.3vw + 1rem);
    }

    .section .title {
      font-size: calc(2vw + 1rem);
    }
    .section span {
      font-size: calc(0.5vw + 1rem);
    }
  }
</style>
